{{

SP03 Text-to-Speech Module i2c interface object

Joe Lucia

}}

CON
  SP03Address                = $C4

  {{
   volume=0(loudest)-7(quietest)
   pitch=0(highest)-7(lowest)
   speed=0(slowest)-3(fastest)
  }}
  SPvolume      =0
  SPpitch       =4
  SPspeed       =2
   
OBJ
  i2c : "i2cObject"

VAR
  byte  started
  
PUB Init(_i2cSDAPin, _i2cSCLPin) : OK
  if OK:=i2c.init(_i2cSDAPin, _i2cSCLPin, 0)
    OK:=i2c.Start

  started:=OK
     
PUB Stop
  i2c.Stop
  started:=0

{{

*************************************************************
* Text to Speech Output Functions
*************************************************************}}
PUB isPresent : OK
  OK := started and i2c.devicePresent(SP03Address)

PUB isBusy
  ' return the last range
  result:=false
  if started
    i2c.i2cStart
    i2c.i2cWrite(SP03Address | 0,8)
    i2c.i2cWrite(0,8)
    i2c.i2cStart
    i2c.i2cWrite(SP03Address | 1,8)
    result := i2c.i2cRead(i2c#_i2cNAK)
    i2c.i2cStop

PUB LoadBuffer(str_ptr, volume, pitch, speed)
  if started
    i2c.i2cStart
    i2c.i2cWrite(SP03Address | 0, 8)
    i2c.i2cWrite(0,8)                                   'Command
    i2c.i2cWrite(0,8)                                   'NOP to load buffer
    i2c.i2cWrite(volume,8)
    i2c.i2cWrite(pitch,8)
    i2c.i2cWrite(speed,8)
    repeat strsize(str_ptr)
      i2c.i2cWrite(byte[str_ptr++],8)
    i2c.i2cWrite(0,8)                                   'NULL termination
    i2c.i2cStop
      

PUB PlayBuffer(bufnum)
  if started
    i2c.i2cStart
    i2c.i2cWrite(SP03Address | 0, 8)
    i2c.i2cWrite(0,8)                                   'Command
    i2c.i2cWrite(bufnum,8)                              'buffer to play, $40=text-buffer that LoadBuffer loaded
    i2c.i2cStop  

PUB Speak(str_ptr)
  if started
    repeat while isBusy
    LoadBuffer(str_ptr, SPvolume, SPpitch, SPspeed)
    PlayBuffer($40)
    repeat while isBusy